#ifndef ABSTRACTSOFTWARE_SEEN
#define ABSTRACTSOFTWARE_SEEN

#include "elementsCollection.h"
#include "globalParameters.h"
#include "particleBeam.h"

#include <iostream>
#include <string>

using namespace std;

class abstractSoftware
{

 protected :

  globalParameters* globParamPtr_;
  elementsCollection* beamLinePtr_;


  abstractSoftware();

  bool launchJob(string commandLine, string& resul);

 public :

  abstractSoftware(globalParameters* globals, elementsCollection* beamLine);
  ~abstractSoftware() {;}

  virtual bool createInputFile(particleBeam* beamBefore,unsigned int numeroDeb, unsigned int numeroFin, string workingDir) = 0;


  virtual bool  execute(unsigned int numeroDeb,unsigned int numeroFin,string workingDir,string& resul) = 0;

 virtual bool buildBeamAfterElements(unsigned int numeroDeb,unsigned int numeroFin, vector<particleBeam>& beams, string workingDir) = 0;


};
#endif
